#ifndef CYGONCE_DEVS_ETH_GRETH_IF_GRETH_H
#define CYGONCE_DEVS_ETH_GRETH_IF_GRETH_H

/*==========================================================================
//
//        if_greth.h
//
//
//==========================================================================
//####ECOSGPLCOPYRIGHTBEGIN####
// -------------------------------------------
// This file is part of eCos, the Embedded Configurable Operating System.
// Copyright (C) 1998, 1999, 2000, 2001, 2002, 2003 Red Hat, Inc.
//
// eCos is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 or (at your option) any later version.
//
// eCos is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with eCos; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
//
// As a special exception, if other files instantiate templates or use macros
// or inline functions from this file, or you compile this file and link it
// with other works to produce a work based on this file, this file does not
// by itself cause the resulting work to be covered by the GNU General Public
// License. However the source code for this file must still be made available
// in accordance with section (3) of the GNU General Public License.
//
// This exception does not invalidate any other reasons why a work based on
// this file might be covered by the GNU General Public License.
//
// Alternative licenses for eCos may be arranged by contacting Red Hat, Inc.
// at http://sources.redhat.com/ecos/ecos-license/
// -------------------------------------------
//####ECOSGPLCOPYRIGHTEND####
//==========================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s):   Gaisler Research (Kristoffer Carlsson <kristoffer@gaisler.com>)
// Contributors:  
// Date:          2005-11-29
// Description:
//
//####DESCRIPTIONEND####
*/

#include <pkgconf/devs_eth_greth.h>
#define GRETH_FD 0x10
#define GRETH_RESET 0x40
#define PHY_ADDR 0
#define GRETH_MII_BUSY 0x8
#define GRETH_MII_NVALID 0x10

#define GRETH_BD_EN 0x800
#define GRETH_BD_WR 0x1000
#define GRETH_BD_IE 0x2000
#define GRETH_BD_LEN 0x7FF

#define GRETH_INT_TX 0x8
#define GRETH_TXEN 0x1
#define GRETH_TXI 0x4
#define GRETH_TXBD_STATUS 0xFFFFC000
#define GRETH_TXBD_ERR_UE 0x4000
#define GRETH_TXBD_ERR_AL 0x8000
#define GRETH_TXBD_NUM CYGINT_DEVS_ETH_GRETH_TxNUM
#define GRETH_TXBD_NUM_MASK GRETH_TXBD_NUM-1
#define GRETH_TX_BUF_SIZE 1516

#define GRETH_INT_RX 0x4
#define GRETH_RXEN 0x2
#define GRETH_RXI 0x8
#define GRETH_RXBD_STATUS 0xFFFFC000
#define GRETH_RXBD_ERR_AE 0x4000
#define GRETH_RXBD_ERR_FT 0x8000
#define GRETH_RXBD_ERR_CRC 0x10000
#define GRETH_RXBD_ERR_OE 0x20000
#define GRETH_RXBD_NUM CYGINT_DEVS_ETH_GRETH_RxNUM
#define GRETH_RXBD_NUM_MASK GRETH_RXBD_NUM-1
#define GRETH_RX_BUF_SIZE 1516

/* Ethernet configuration registers */
typedef struct _greth_regs {
  volatile cyg_uint32    control;        
  volatile cyg_uint32    status;        
  volatile cyg_uint32    esa_msb;        
  volatile cyg_uint32    esa_lsb;        
  volatile cyg_uint32    mdio;        
  volatile cyg_uint32    tx_desc_p;        
  volatile cyg_uint32    rx_desc_p;        
} greth_regs;

/* Ethernet buffer descriptor */
typedef struct _greth_bd {
  cyg_uint32    stat;
  cyg_uint32    addr;           /* Buffer address */
} greth_bd;


/* The buffer descriptors track the ring buffers.  */
struct bd_info {

  volatile greth_bd *tx_ring;		/* Address of Tx BDs. */
  cyg_uint32 tx_next;			/* Next buffer to be sent */
  cyg_uint32 tx_last;			/* Next buffer to be checked if packet sent */
  cyg_uint32 tx_free;			/* Number of free tx descriptors */
  cyg_uint32 tx_keys[GRETH_TXBD_NUM];	/* remember tx keys */

  volatile greth_bd *rx_ring;		/* Address of Rx BDs. */
  cyg_uint32 rx_cur;			/* Next buffer to be checked if packet received */
};


typedef struct _greth_info {
  greth_regs *regs;            /* Address of controller registers. */  

  struct bd_info bdi;
  
  cyg_uint8 esa[6];
  struct eth_drv_sc *sc;
  cyg_uint32 idx;
  cyg_uint32 active;

  // Interrupt handling stuff
  cyg_uint32 irq;
  cyg_vector_t    vector;             // interrupt vector
  cyg_handle_t    interrupt_handle;   // handle for int.handler
  cyg_interrupt   interrupt_object;

} greth_info;



#endif 


