#ifndef CYGONCE_HAL_XPIC_H
#define CYGONCE_HAL_XPIC_H

//=============================================================================
//
//      hal_xpic.h
//
//      HAL eXternal Programmable Interrupt Controller support
//
//=============================================================================
//####ECOSGPLCOPYRIGHTBEGIN####
// -------------------------------------------
// This file is part of eCos, the Embedded Configurable Operating System.
// Copyright (C) 1998, 1999, 2000, 2001, 2002 Red Hat, Inc.
//
// eCos is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 or (at your option) any later version.
//
// eCos is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with eCos; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
//
// As a special exception, if other files instantiate templates or use macros
// or inline functions from this file, or you compile this file and link it
// with other works to produce a work based on this file, this file does not
// by itself cause the resulting work to be covered by the GNU General Public
// License. However the source code for this file must still be made available
// in accordance with section (3) of the GNU General Public License.
//
// This exception does not invalidate any other reasons why a work based on
// this file might be covered by the GNU General Public License.
//
// Alternative licenses for eCos may be arranged by contacting Red Hat, Inc.
// at http://sources.redhat.com/ecos/ecos-license/
// -------------------------------------------
//####ECOSGPLCOPYRIGHTEND####
//=============================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s):   nickg, gthomas, hmt
// Contributors:        nickg, gthomas, hmt
// Date:        1999-01-28
// Purpose:     Define Interrupt support
// Description: The macros defined here provide the HAL APIs for handling
//              an external interrupt controller, and which interrupt is
//              used for what.
//
// Usage:
//              #include <cyg/hal/hal_intr.h> // which includes this file
//              ...
//
//
//####DESCRIPTIONEND####
//
//=============================================================================

#include <cyg/hal/hal_io.h>
#include <cyg/hal/hal_smp.h>
#include <cyg/hal/hal_leon3.h>


// Priority constants
#define CYGNUM_HAL_PRIORITY_0    0
#define CYGNUM_HAL_PRIORITY_1    1
#define CYGNUM_HAL_PRIORITY_2    2
#define CYGNUM_HAL_PRIORITY_3    3
#define CYGNUM_HAL_PRIORITY_4    4
#define CYGNUM_HAL_PRIORITY_5    5
#define CYGNUM_HAL_PRIORITY_6    6
#define CYGNUM_HAL_PRIORITY_7    7
#define CYGNUM_HAL_PRIORITY_8    8
#define CYGNUM_HAL_PRIORITY_9    9
#define CYGNUM_HAL_PRIORITY_10  10
#define CYGNUM_HAL_PRIORITY_11  11
#define CYGNUM_HAL_PRIORITY_12  12
#define CYGNUM_HAL_PRIORITY_13  13
#define CYGNUM_HAL_PRIORITY_14  14
#define CYGNUM_HAL_PRIORITY_15  15
#define CYGNUM_HAL_PRIORITY_16  16
#define CYGNUM_HAL_PRIORITY_17  17
#define CYGNUM_HAL_PRIORITY_18  18
#define CYGNUM_HAL_PRIORITY_19  19
#define CYGNUM_HAL_PRIORITY_20  20
#define CYGNUM_HAL_PRIORITY_21  21
#define CYGNUM_HAL_PRIORITY_22  22
#define CYGNUM_HAL_PRIORITY_23  23
#define CYGNUM_HAL_PRIORITY_24  24
#define CYGNUM_HAL_PRIORITY_25  25
#define CYGNUM_HAL_PRIORITY_26  26
#define CYGNUM_HAL_PRIORITY_27  27
#define CYGNUM_HAL_PRIORITY_28  28
#define CYGNUM_HAL_PRIORITY_29  29
#define CYGNUM_HAL_PRIORITY_30  30
#define CYGNUM_HAL_PRIORITY_31  31

#define CYGNUM_HAL_PRIORITY_MIN                CYGNUM_HAL_PRIORITY_0
#define CYGNUM_HAL_PRIORITY_MAX                CYGNUM_HAL_PRIORITY_31
#define CYGNUM_HAL_PRIORITY_COUNT              32


//-----------------------------------------------------------------------------
// Interrupt controller access

// The vector used by the Real time clock
externC cyg_uint32 hal_sparc_leon3_clock_irqnr(void);
#define CYGNUM_HAL_INTERRUPT_RTC hal_sparc_leon3_clock_irqnr()


externC cyg_uint32 leon3_disable_irq(cyg_uint32 irq_nr, cyg_uint32 arg2, cyg_uint32 arg3);
externC cyg_uint32 leon3_enable_irq(cyg_uint32 irq_nr, cyg_uint32 arg2, cyg_uint32 arg3);

#ifndef _GRSIM_
externC cyg_uint32 leon3_acknowledge_irq(cyg_uint32 irq_nr, cyg_uint32 arg2, cyg_uint32 arg3);
#endif /* GRSIM */

#define HAL_INTERRUPT_MASK( _vector_ ) \
  (gighook[GIGHOOK_ECOS_HAL_INTERRUPT_MASK])((cyg_uint32)(_vector_),(cyg_uint32)(0),(cyg_uint32)(0))

#define HAL_INTERRUPT_UNMASK( _vector_ ) \
  (gighook[GIGHOOK_ECOS_HAL_INTERRUPT_UNMASK])((cyg_uint32)(_vector_),(cyg_uint32)(0),(cyg_uint32)(0))

#ifdef _GRSIM_

#define HAL_INTERRUPT_ACKNOWLEDGE( _vector_ )              /* nothing */

#else /* _GRSIM_ */

#define HAL_INTERRUPT_ACKNOWLEDGE( _vector_ ) \
  (gighook[GIGHOOK_ECOS_HAL_INTERRUPT_ACKNOWLEDGE])((cyg_uint32)(_vector_),(cyg_uint32)(0),(cyg_uint32)(0))

#endif /* _GRSIM_ */

#define HAL_INTERRUPT_CONFIGURE( _vector_, _level_, _up_ ) /* nothing */

#define HAL_INTERRUPT_SET_LEVEL( _vector_, _level_ ) /* nothing */


//-----------------------------------------------------------------------------
#endif // ifndef CYGONCE_HAL_XPIC_H
// End of hal_xpic.h
