// ====================================================================
//
//  HAL bootup platform-oriented code (assembler)
//
// ====================================================================
//####ECOSGPLCOPYRIGHTBEGIN####
// -------------------------------------------
// This file is part of eCos, the Embedded Configurable Operating System.
// Copyright (C) 1998, 1999, 2000, 2001, 2002 Red Hat, Inc.
//
// eCos is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 or (at your option) any later version.
//
// eCos is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with eCos; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
//
// As a special exception, if other files instantiate templates or use macros
// or inline functions from this file, or you compile this file and link it
// with other works to produce a work based on this file, this file does not
// by itself cause the resulting work to be covered by the GNU General Public
// License. However the source code for this file must still be made available
// in accordance with section (3) of the GNU General Public License.
//
// This exception does not invalidate any other reasons why a work based on
// this file might be covered by the GNU General Public License.
//
// Alternative licenses for eCos may be arranged by contacting Red Hat, Inc.
// at http://sources.redhat.com/ecos/ecos-license/
// -------------------------------------------
//####ECOSGPLCOPYRIGHTEND####
// ====================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s):           Gaisler Research, (Konrad Eisele<eiselekd@web.de>)
// Contributors:
// Date:          1999-02-01
// Purpose:          Bootup code, platform oriented.
// Description:
//
//####DESCRIPTIONEND####
//
// ====================================================================

#include <pkgconf/system.h>
#include <pkgconf/hal.h>
#include <cyg/hal/hal_amba.h>
#include <pkgconf/hal_sparc_leon3.h>

!unsigned int ahbslv_scan(register unsigned int vendor,register unsigned int driver) {
!  register unsigned int conf, mbar,i, *confp;
!  register unsigned int cfg_area = (unsigned int ) (LEON3_IO_AREA | LEON3_CONF_AREA | LEON3_AHB_SLAVE_CONF_AREA);
!  for (i = 0; i < LEON3_AHB_SLAVES; i++)
!  {
!    confp = (unsigned int*)(cfg_area + (i * LEON3_AHB_CONF_WORDS * 4));
!    conf = *confp;
!    //mbar = *(unsigned int*)(i * LEON3_AHB_CONF_WORDS+ (4 * 4));
!    if ((amba_vendor(conf) == vendor) && (amba_device(conf) == driver)) {
!      return (unsigned int)confp;
!    }
!  }
!  return 0;
!}

  .section  ".text"
  .align 4
ahbslv_scan:
  mov  %o0, %g1
  mov  -2048, %o5
  mov  0, %o3
  sll  %o3, 5, %o0
.LL11:
  add  %o5, %o0, %o4
  ld  [%o5+%o0], %o2
  srl  %o2, 24, %o0
  cmp  %o0, %g1
  bne,a  .LL10
  add  %o3, 1, %o3
  srl  %o2, 12, %o0
  and  %o0, 4095, %o0
  cmp  %o0, %o1
  be  .LL1
  mov  %o4, %o2
  add  %o3, 1, %o3
.LL10:
  cmp  %o3, 63
  bleu,a  .LL11
  sll  %o3, 5, %o0
  mov  0, %o2
.LL1:
  retl
  mov  %o2, %o0


!unsigned int apbslv_scan(register unsigned int base,register unsigned int vendor, register unsigned int driver) {
!  register unsigned int conf, mbar,i, *confp;
!  for (i = 0; i < LEON3_APB_SLAVES; i++)
!  {
!    confp = (unsigned int*)(base + (i * LEON3_APB_CONF_WORDS * 4));
!    conf = *confp;
!    //mbar = *(unsigned int*)(i * LEON3_AHB_CONF_WORDS+ (4 * 4));
!    if ((amba_vendor(conf) == vendor) && (amba_device(conf) == driver)) {
!      return (unsigned int)confp;
!    }
!  }
!  return 0;
!}



  .section  ".text"
  .align 4

apbslv_scan:
  mov  %o0, %g1
  mov  0, %o4
  sll  %o4, 3, %o0
.LL22:
  add  %g1, %o0, %o5
  ld  [%g1+%o0], %o3
  srl  %o3, 24, %o0
  cmp  %o0, %o1
  bne,a  .LL21
  add  %o4, 1, %o4
  srl  %o3, 12, %o0
  and  %o0, 4095, %o0
  cmp  %o0, %o2
  be  .LL12
  mov  %o5, %o3
  add  %o4, 1, %o4
.LL21:
  cmp  %o4, 15
  bleu,a  .LL22
  sll  %o4, 3, %o0
  mov  0, %o3
.LL12:
  retl
  mov  %o3, %o0



!unsigned int getbase(register unsigned int *mbar,register unsigned int iobase) {
!  register unsigned int conf = mbar[1];
!  return ((iobase & 0xfff00000) |
!          ((conf & 0xfff00000)>> 12)) & (((conf & 0x0000fff0) <<4) | 0xfff00000);
!
!}


  .section  ".text"
  .align 4

getbase:
  ld  [%o0+4], %o2
  sethi  %hi(-1048576), %o3
  and  %o1, %o3, %o1
  and  %o2, %o3, %o0
  srl  %o0, 12, %o0
  or  %o1, %o0, %o1
  sethi  %hi(64512), %o0
  or  %o0, 1008, %o0
  and  %o2, %o0, %o2
  sll  %o2, 4, %o2
  or  %o2, %o3, %o2
  and  %o1, %o2, %o1
  retl
  mov  %o1, %o0


#define BOOTLOADER_FREQ_KHZ 400000
#define BOOTLOADER_SRAMSZ_KB 4096
#define BOOTLOADER_SDRAMSZ_MB 0
#define BOOTLOADER_BAUD 38400

#define BOOTLOADER_memcfg1  0x28022
#define BOOTLOADER_memcfg2  0x4201220
#define BOOTLOADER_uart     0xa2
#define BOOTLOADER_loopback 0x0
#define BOOTLOADER_flow     0x0
#define BOOTLOADER_ftreg    0x0

#define BOOTLOADER_grlib_sdram 0x420013b

#define BOOTLOADER_freq      40500000

#define BOOTLOADER_ramsize   0x3ff000
#define BOOTLOADER_romsize   0x800000
#define BOOTLOADER_stack     0x403fefe0

#define START_USING_DSU




  .global hal_sparc_leon_init
  .global LEON3_IrqCtrl_Regs, LEON3_GpTimer_Regs, LEON3_APBUART_Regs
hal_sparc_leon_init:

  flush

#ifdef CYGPKG_HAL_SMP_SUPPORT
        !lda [%g0] 2, %g1           ! init cache
  !set 0x800000, %g2          ! snooping enable
        !or  %g2, %g1, %g2

        !set  0x800000, %g2   ! snooping,disable cache for test

        !sta %g2, [%g0] 2          ! init cache

  !set  0x81000f, %g2   ! snooping enable
        !set  0x800000, %g2   ! snooping enable
#else
  !set  0x01000f, %g2
        !set  0x000000, %g2
        !sta %g2, [%g0] 2          ! init cache
#endif

  clr  %g1
  clr  %g2
  clr  %g3
  clr  %g4
  clr  %g5
  clr  %g6
  mov  %o7,%g7

        set VENDOR_GAISLER, %o0
        set GAISLER_APBMST, %o1
        call ahbslv_scan
        nop

        cmp %g0,%o0
        be .goonhardreset
         nop

        ld [%o0+16],%g1
        set LEON3_IO_AREA,%o0
        and %g1,%o0,%g1            !g1: apb base

        set LEON3_CONF_AREA,%o0
        or %g1,%o0,%g2             !g2: apb conf base

  ! *********** irq *****************
        mov %g2,%o0
        set VENDOR_GAISLER, %o1
        set GAISLER_IRQMP,%o2
        call apbslv_scan
         nop
        cmp %g0,%o0
        be .goonhardreset
         nop

        call getbase
         mov %g1,%o1

#ifdef _GRSIM_

        st    %g0, [%o1 + 0x0]  !irq pri
        st    %g0, [%o1 + 0x4]  !irq pend
        st    %g0, [%o1 + 0x8]  !irq force
        st    %g0, [%o1 + 0xC]  !irq clear
        st    %g0, [%o1 + 0x40]  !irq mask

  set   LEON3_IrqCtrl_Regs,%o0
  st    %o1,[%o0]

#else

  set   LEON3_IrqCtrl_Regs_Read,%o0
  st    %o1,[%o0]
  set   LEON3_IrqCtrl_Regs_Write,%o0
  st    %o1,[%o0]

#endif

  ! *********** timer *****************

        mov %g2,%o0
        set VENDOR_GAISLER, %o1
        set GAISLER_GPTIMER,%o2
        call apbslv_scan
         nop
        cmp %g0,%o0
        be .goonhardreset
         nop

        call getbase
         mov %g1,%o1
  set  (AMBA_FREQ_KHZ+500)/1000, %o0    ! Load timer scaler register
  sub  %o0, 1, %o0
    st  %o0, [%o1 + 0x00] ! scaler
    st  %o0, [%o1 + 0x04] ! scaler reload

#ifdef _GRSIM_

  set   LEON3_GpTimer_Regs,%o0

#else

  set   LEON3_GpTimer_2_Regs,%o0

#endif

  st    %o1,[%o0]

#ifndef START_USING_DSU

  ! ************ mctrl ************
/*
        mov %g2,%o0
        set VENDOR_ESA, %o1
        set ESA_MCTRL,%o2
        call apbslv_scan
         nop
        cmp %g0,%o0
        be .LL1mctlsdram
         nop

        call getbase
         mov %g1,%o1

#define MCTRLBASE %g4
        mov %o1,MCTRLBASE             !mctrl base address

  set  BOOTLOADER_memcfg1, %o0    ! Load memory config register 1
  ld  [%o1+0x00], %o2    !
  and  %o2, 0x300, %o2
  or  %o0, %o2, %o0
    st  %o0, [%o1 + 0x00]

  set  BOOTLOADER_memcfg2, %o0    ! Load memory config register 2
#if !( defined(TSIM) || !defined(BZIMAGE))
  st  %o0, [%o1 + 0x04]    ! only for prom version, else done by "dumon -i"
#endif
  set  BOOTLOADER_ftreg, %o0    ! Init FT register
  st  %o0, [%o1 + 0x08]
    ld  [%o1 + 0x08], %o0
  srl  %o0, 30, %o0
  andcc  %o0, 3, %g6
  bne,a  1f
  mov  %g0, %asr16    ! clear err_reg
1:
  ba  .LL1mctlok
  nop


  ! ************ gaisler sdram mctrl ************

.LL1mctlsdram:

        set VENDOR_GAISLER, %o0
        set GAISLER_SDCTRL, %o1
        call ahbslv_scan
        nop

        cmp %g0,%o0
        be .LL1mctlok                ! assuming sram/prom ctrl
         nop

        ld [%o0+16+4],%g1            ! get io bar
        set LEON3_IO_AREA,%o0
        and %g1,%o0,%g1
  srl %g1,12,%g1
        or  %g1,%o0,%g1


  set  BOOTLOADER_grlib_sdram, %o0
  st  %o0, [%g1 + 0x100]
*/
  ! ************ uart ************

#endif //!START_USING_DSU
/*
.LL1mctlok:
        mov %g2,%o0
        set VENDOR_GAISLER, %o1
        set GAISLER_APBUART,%o2
        call apbslv_scan
         nop
        cmp %g0,%o0
        be .goonhardreset
         nop

        call getbase
         mov %g1,%o1

#define UARTBASE %g5
        mov %o1,UARTBASE             !uart base address


        !########################################################
        ! initialization: protect g5 (uartbase)

  !set  BOOTLOADER_uart, %g2    ! Load UART scaler register
  !st  %g2, [UARTBASE + 0x0c]  ! uart scalar !st  %g2, [%g1 + 0x0c]

        ld [UARTBASE + 0x08], %o0
        or %o0,0x3,%o0
#if defined(CONFIG_UARTLOOPBACK) || (BOOTLOADER_loopback==1)
  !set  0x83|(BOOTLOADER_flow<<6), %g2      ! Enable uarts, (flow ctrl), loopback
#else
  !set  0x03|(BOOTLOADER_flow<<6), %g2      ! Enable uarts, (flow ctrl)
#endif
    st  %o0, [UARTBASE + 0x08]

        !set  0xc3|(BOOTLOADER_flow<<6), %g2      ! Enable uarts, (flow ctrl)
    !st  %g2, [UARTBASE + 0x08]

  set LEON3_APBUART_Regs,%o0
  st UARTBASE,[%o0]

*/
  !#######################################################
  ! end

        ! then copy the branch instructions into the vector

  rd  %tbr, %g1
  andn  %g1, 0xfff, %g1    ! clear non-address bits
  sethi  %hi(real_vector_instructions_copy), %l0
  or  %l0, %lo(real_vector_instructions_copy), %l0

#if CYGHWR_HAL_SPARC_MULTIPLE_VECTOR_TRAPPING
#if !defined(CYGPKG_HAL_SMP_SUPPORT)
  ld  [ %l0 ], %l1
  st  %l1, [ %g1 ]    ! into the vector
  ld  [ %l0 + 4 ], %l1
  st  %l1, [ %g1 + 4 ]  ! into the vector
#endif
#endif

.goonhardreset:

#ifndef START_USING_DSU
  set  BOOTLOADER_stack, %fp
  andn  %fp, 0x0f, %fp
  sub  %fp, 64, %sp
#endif

  mov  %g7,%o7
        retl
   nop

real_vector_instructions_copy:
  rd  %tbr, %l3
  rd  %psr, %l0

